/*
 Name:		smartSystems.ino
 Created:	14/11/2017 13:45:53
 Author:	egode
*/

//----------------------------------------------------
//For bryter som verifiserer at godteri kommer ut
#define bryter A0
int harKjort = 0;
//----------------------------------------------------
//For steppermotorene
#define steps 40								//Antall steps per porsjon 200/antall blader p impeller
#define wait 2500
#define pul 2
#define dir 3
int ena[2][6] = {								//ena[0][x] = pinne nr.
	{ 31, 33, 35, 37},							//ena[1][x] = tilstand (aktiver/deaktiver)
	{ 0, 0, 0, 0} 
};
int kjor;
//----------------------------------------------------
//For avstandssensoren som mler mengden i beholderene
int in[4] = { A0, A1, A2, A3 };
#define resolution 200
float value[resolution][4];
float quantitySensToCm[50][2];
float C = 0;
float avstand[4];
float median[4];
float verdi[4];
//----------------------------------------------------
//For vekt
#include "HX711.h"
HX711 scale(12, 11);; //pin 11 & 12, 5V on 13
float calibration_factor = 2100;
float units;
//----------------------------------------------------

void setup() {
	Serial.begin(9600);

	for (int u = 0; u < 50; u++) {
		float x = u+1;
		C = 8.1 + (x * 0.4);
		quantitySensToCm[u][0] = x;
		quantitySensToCm[u][1] = 489 * exp((10 - x) / C);
	}
	for (int i = 0; i < 50; i++) {
		Serial.print(quantitySensToCm[i][1]);
		Serial.print("   ");
	}
	Serial.println();
	for (int i = 0; i < 50; i++) {
		Serial.print(quantitySensToCm[i][0]);
		Serial.print("   ");
	}

	pinMode(pul, 1);
	pinMode(dir, 1);
	for (int g = 0; g < 6; g++) {
		pinMode(ena[0][g], 1);
	}
	pinMode(bryter, 0);
	
	kjor = 0;
	harKjort = 1;

	//Vekt
	pinMode(13, 1);
	digitalWrite(13, 1);
	delay(100);
	scale.set_scale(calibration_factor);
	scale.tare();
}


/*-------------------------------------------------------------------------------------
Mengde godteri igjen i hver beholder	avstand[x]		float
Type godteris som skal kjres			ena[0][x]		int
Mengde godteri som aksl kjres			ena[1][x]		int
---------------------------------------------------------------------------------------
*/

void loop() {
	DistanceSensor();
	StepperMotor();
	LesSerial();
	//Weight();
}

void LesSerial() {
	int n = 0;
	int m = 100;
	char kjorChar[100];
	for (int i = 0; i < m; i++) {
		kjorChar[i] = 0;
	}
	while (Serial.available() > 0) {						//Leser inn flere verdier og sette sammen fra serial
		kjorChar[n] = Serial.read();						//Leser hvor mange porsjoner som skal kjres
		n++;
		delay(10);
	}
	int i = 0;
	int k = 0;
	while (k < n) {
		int dont = 0;
		if (kjorChar[k] == 'a') {
			i = 0;
			k++;
		}
		else if (kjorChar[k] == 'b') {
			i = 1;
			k++;
		}
		else if (kjorChar[k] == 'd') {
			i = 2;
			k++;
		}
		else if (kjorChar[k] == 'c') {
			i = 3;
			k++;
		}
		else if (kjorChar[k] == 's') {
			adjustment();
		}
		if ((kjorChar[k] - '0') < 10 && (kjorChar[k] - '0') >= 0) {
			ena[1][i] = (ena[1][i] * 10) + (kjorChar[k] - '0');					//Gjr om fra char til int
			if (ena[1][i] > kjor) {
				kjor = ena[1][i];												//Gjr om fra char til int
			}
		}
		k++;
	}
}

void StepperMotor(){
	while (kjor > 0) {										//Sjekker om funksjonen skal gjre en jobb
		for (int g = 0; g < 5; g++) {
			digitalWrite(ena[0][g], ena[1][g]);				//Bestemmer hvilken motor som skal kjres
		}

		digitalWrite(dir, 1);

		for (int i = 0; i < steps; i++) {					//Stepper antall steps som blir en porsjon
			digitalWrite(pul, 1);							//1/antall blader p impeller * 200 steps
			delayMicroseconds(wait);
			digitalWrite(pul, 0);
			delayMicroseconds(wait);
		}
		harKjort = 1;
		for (int i = 0; i < 5; i++) {
			if (ena[1][i] > 0) {
				ena[1][i] = ena[1][i] - 1;
			}
		}
		kjor = kjor - 1;
	}
	for (int g = 0; g < 5; g++) {
		digitalWrite(ena[0][g], 0);							//Deaktiverer alle motorer
	}
}

void adjustment() {
	int steg;
	bool adj = 1;
	while (adj) {
		while (!Serial.available()) {}
		char adjC = Serial.read();
		if (adjC == 'x') {
			adj = 0;
		}
		else if (adjC == 'a') {
			digitalWrite(ena[0][0], 1);
		}
		else if (adjC == 'b') {
			digitalWrite(ena[0][1], 1);
		}
		else if (adjC == 'd') {
			digitalWrite(ena[0][2], 1);
		}
		else if (adjC == 'c') {
			digitalWrite(ena[0][3], 1);
		}
		delay(500);
			digitalWrite(pul, 1);
			delayMicroseconds(5000);
			digitalWrite(pul, 0);
			delayMicroseconds(5000);

			digitalWrite(ena[0][0], 0);
			digitalWrite(ena[0][1], 0);
			digitalWrite(ena[0][2], 0);
			digitalWrite(ena[0][4], 0);
	}
}

void DistanceSensor() {
	if (harKjort) {											//Sjekker om funksjonen skal gjre en jobb
		harKjort = 0;
		//---------------------------------------------------------------------------------------------
		for (int i = 0; i < 4; i++) {						//Fjerner gamle verdier
			avstand[i] = 0;
			median[i] = 0;
			verdi[i] = 0;
		}
		//---------------------------------------------------------------------------------------------

		for (int i = 0; i < resolution; i++) {				//Leser inn posisjonsdata fra sensor
			value[i][0] = analogRead(in[0]);
			value[i][1] = analogRead(in[1]);
			value[i][2] = analogRead(in[2]);
			value[i][3] = analogRead(in[3]);
			delayMicroseconds(100);
		}

		for (int j = 0; j < resolution; j++) {				//Sorterer data i stigende rekkeflge
			for (int k = 0; k < resolution; k++) {
				for (int i = 0; i < 4; i++){
					if (value[k][i] > value[k + 1][i]) {
						int b = value[k + 1][i];
						value[k + 1][i] = value[k][i];
						value[k][i] = b;
					}
				}
			}
		}

		median[0] = value[resolution / 2][0];						//Finner median
		median[1] = value[resolution / 2][1];
		median[2] = value[resolution / 2][2];
		median[3] = value[resolution / 2][3];

		for (int i = 0; i < 50; i++) {						//Sammenlikner median med verdier i register
				for (int f = 0; f < 4; f++) {
					if (quantitySensToCm[i][1] > median[f]) {
					avstand[f] = quantitySensToCm[i][0];			//Henter avstand i cm fra register
					verdi[f] = quantitySensToCm[i][1];			//Sensorverdi for avstand fra register
				}
			}
		}
	}
}

void Weight() {
	units = scale.get_units(), 10;
	if (units < 0)
	{
		units = 0.00;
	}
	Serial.println(units);
}










